# ibcmdrunner

## Библиотека для упрощения работы с утилитами ibcmd и ibsrv из oscript.

Позволяет выполнять операции с информационной базой в стиле [v8runner](https://github.com/oscript-library/v8runner).

Пример работы:

```bsl

УправлениеИБ = Новый УправлениеИБ;
ВременныйКаталог = ОбъединитьПути(КаталогВременныхФайлов(), "tmp_db");
УправлениеИБ.УстановитьПараметрыФайловойИБ(ВременныйКаталог);
ПутьКФайлуКонфигурации = "c:\tmp\1c.cf";
УправлениеИБ.СоздатьИБИзФайлаКонфигурации(ПутьКФайлуКонфигурации);
```

```bsl

КонфигФайл = Новый КонфигурационныйФайлАС;
// Задаем параметры автономного сервера - IP-адрес, порт (по умолчанию 8314), имя сервера
КонфигФайл.ПараметрыСервера("127.0.0.1", , "MyFirstServer");
// Задаем параметры информационной базы, к которой подключаемся -
// путь, имя пользователя, пароль
КонфигФайл.ПараметрыФайловойБД("d:\1c_Bases\MyBase", "user", "123");
// Создаем конфигурационный файл c:\tmp\my-config.yml в формате YAML
КонфигФайл.СоздатьКонфигурационныйФайл("c:\tmp\my-config.yml");
```

## [Программный интерфейс](https://github.com/alex-bob-lip/ibcmdrunner/tree/main/doc/doc.md)

## Лицензия

Смотри файл [`LICENSE`](./LICENSE).
